const
 //QKEY = (1 shl 6) + 5;
 QPERM = (6 shl 6) + (6 shl 3);
 MAXOBN = 50;
 MAXPRIOR = 10;

type
 q_entry = record
  mtype:longint;
  mtext:array [0..MAXOBN] of char;
 end;
 pq_entry = ^q_entry;
 
var
 IPCError:longint;
 QKEY:TKey;

procedure warn(msg:String);
begin
 writeln(stderr,'Предупреждение: ',msg,' errno:',fpgeterrno);
end;



function init_queue:longint;
var
 queue_id:longint;
begin
 QKey := Ftok('.',1);
 writeln('Инициализация очереди.');
 queue_id := msgget(QKEY,IPC_CREAT or QPERM);
 if(queue_id = -1)then warn('Неудалось инициализировать очередь сообщений');
 init_queue := queue_id;
 writeln('очередь инициализирована. Идентификатор очереди: ', queue_id);
end;

function proc_obj(msg:pq_entry):integer;
begin
 writeln(#$a'Приоритет: ', msg^.mtype, ' Имя: ',msg^.mtext);
end;
 
function enter(objname:String; priority:Longint):Boolean;
var
 len, s_qid:longint;
 s_entry:q_entry;
begin
 len := length(objname);
 enter := false;
 if(len > MAXOBN)then begin
  warn('Слишком длинное имя!');
  exit;
 end;
 if(priority > MAXPRIOR)then begin
  warn('Недопустимый уровень приоритета.');
  exit;
 end;
 s_qid := init_queue;
 if(s_qid = -1)then exit;
 s_entry.mtype := priority;
 strlcopy(s_entry.mtext, @objname[1], MAXOBN);
 if (msgsnd(s_qid, @s_entry, MAXOBN, 0) = -1)then begin
  warn('Не удалось отправить сообщение.');
  exit;
 end;
 enter := true;
end;

function serve:integer;
var
 r_qid:longint;
 r_entry:q_entry;
begin
 serve := -1;
 r_qid := init_queue;
 if (r_qid = -1)then exit;
 writeln('Чтение сообщений');
 while true do begin
  if (msgrcv(r_qid, PMSGBuf(@r_entry), MAXOBN, -1 * MAXPRIOR, 0) = -1)then begin
   warn('Неудачный вызов msgrcv');
   exit;
  end
  else proc_obj(@r_entry);
 end;
end;